import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.Enumeration;

/**
  *
  * Beschreibung:
  *
  * @version 1.0 vom 01.02.2006
  * @author
  */

public class Gui extends JFrame {
    // Anfang Variablen
    
    private static Gui gui;
    private static Moeblierung moeblierung;
    private Zeichenflaeche zeichenflaeche;
    
    private JLabel labelXPosition;
    private JLabel labelYPosition;
    private JLabel labelFarbe;
    private JLabel labelRichtung;
    private JLabel labelBreite;
    private JLabel labelTiefe;
    
    private JTextField editXPosition;
    private JTextField editYPosition;
    private JTextField editFarbe;
    private JTextField editRichtung;
    private JTextField editBreite;
    private JTextField editTiefe;
    
    private JButton uebernehmenButton;
  
    private JPanel jButtonGroup1Panel = new JPanel();
    private ButtonGroup jButtonGroup1 = new ButtonGroup();
      private JRadioButton jButtonGroup1ButtonStuhl = new JRadioButton("Stuhl");
      private JRadioButton jButtonGroup1ButtonTisch = new JRadioButton("Tisch");
      private JRadioButton jButtonGroup1ButtonSchrank = new JRadioButton("Schrank");
      private JRadioButton jButtonGroup1ButtonBett = new JRadioButton("Bett");

      private String ausgewaehlt;
    // Ende Variablen

    /**
     * Konstruktor
     */
    public Gui(String title, int breite, int hoehe) {
        // Frame-Initialisierung
        super(title);
        setJMenuBar(machMenueLeiste());
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent evt) { System.exit(0); }
        });
        
        // Attribute
        setSize(breite, hoehe);
        setLocation(20, 20);
        Container contentPane = getContentPane();
        contentPane.setLayout(null);
    
        // Anfang Komponenten
        labelXPosition = new JLabel("x-Position");
        labelXPosition.setBounds(10, 10, 70, 20);
        contentPane.add(labelXPosition);
        labelYPosition = new JLabel("y-Position");
        labelYPosition.setBounds(10, 40, 70, 20);
        contentPane.add(labelYPosition);
        labelFarbe = new JLabel("Farbe");
        labelFarbe.setBounds(10, 70, 70, 20);
        contentPane.add(labelFarbe);
        labelRichtung = new JLabel("Richtung");
        labelRichtung.setBounds(10, 100, 70, 20);
        contentPane.add(labelRichtung);
        labelBreite = new JLabel("Breite");
        labelBreite.setBounds(10, 130, 70, 20);
        contentPane.add(labelBreite);
        labelTiefe = new JLabel("Tiefe");
        labelTiefe.setBounds(10, 160, 70, 20);
        contentPane.add(labelTiefe);

        
        // Textfelder
        editXPosition = new JTextField("20");
        editXPosition.setBounds(90, 10, 80, 20);
        contentPane.add(editXPosition);
        editYPosition = new JTextField("20");
        editYPosition.setBounds(90, 40, 80, 20);
        contentPane.add(editYPosition);
        editFarbe = new JTextField("rot");
        editFarbe.setBounds(90, 70, 80, 20);
        contentPane.add(editFarbe);
        editRichtung = new JTextField("0");
        editRichtung.setBounds(90, 100, 80, 20);
        contentPane.add(editRichtung);
        editBreite = new JTextField("60");
        editBreite.setBounds(90, 130, 80, 20);
        contentPane.add(editBreite);
        editTiefe = new JTextField("37");
        editTiefe.setBounds(90, 160, 80, 20);
        contentPane.add(editTiefe);
        
        // Buttons
        uebernehmenButton = new JButton ("bernehmen");
        uebernehmenButton.setBounds(10, 200, 160, 20);
        contentPane.add(uebernehmenButton);
        
        // Radiobutton - Gruppe
        final String stuhlMessageCommand = "Stuhl";
        final String tischMessageCommand = "Tisch";
        final String schrankMessageCommand = "Schrank";
        final String bettMessageCommand = "Bett";
        jButtonGroup1Panel.setBounds(24, 240, 140 , 137);
        jButtonGroup1Panel.setLayout(new GridLayout(4, 1));
        jButtonGroup1.add(jButtonGroup1ButtonStuhl);
        jButtonGroup1Panel.add(jButtonGroup1ButtonStuhl);
        jButtonGroup1.add(jButtonGroup1ButtonTisch);
        jButtonGroup1Panel.add(jButtonGroup1ButtonTisch);
        jButtonGroup1.add(jButtonGroup1ButtonSchrank);
        jButtonGroup1Panel.add(jButtonGroup1ButtonSchrank);
        jButtonGroup1.add(jButtonGroup1ButtonBett);
        jButtonGroup1Panel.add(jButtonGroup1ButtonBett);
        contentPane.add(jButtonGroup1Panel);
        jButtonGroup1ButtonSchrank.setSelected(true);ausgewaehlt="Schrank";
        jButtonGroup1ButtonStuhl.setActionCommand(stuhlMessageCommand); 
        jButtonGroup1ButtonTisch.setActionCommand(tischMessageCommand); 
        jButtonGroup1ButtonSchrank.setActionCommand(schrankMessageCommand); 
        jButtonGroup1ButtonBett.setActionCommand(bettMessageCommand); 
        
        // Zeichenflaeche (JPanel)
        zeichenflaeche = new Zeichenflaeche(breite-200, hoehe-100);
        JScrollPane scroll = new JScrollPane(zeichenflaeche);
        scroll.setBounds(180, 10, breite-200, hoehe-100);
        contentPane.add(scroll);
    
        // Ende Komponenten
    
        setResizable(false);
        setVisible(true);
        zeichenflaeche.zeichne(moeblierung);
    
        // Anfang Ereignisprozeduren
        uebernehmenButton.addActionListener(new ActionListener() { // reagiert auf MAUSCLICK
            public void actionPerformed(ActionEvent e) {
                uebernehmenAktion();
            }
        });
        
        zeichenflaeche.addMouseMotionListener(new MouseMotionAdapter() {
            public void mouseMoved(MouseEvent e){
                // Fr Testzwecke:
                // editXPosition.setText(""+e.getX());
                // editYPosition.setText(""+e.getY());
            }
            public void mouseDraged(MouseEvent e){
                int x = e.getX();
                int y = e.getY();
                Object angeklickt = moeblierung.gibMoebelZuPunkt(x, y);
                
            }
        });
        
        
        zeichenflaeche.addMouseListener(new MouseAdapter() {
            public void mouseEntered(MouseEvent e){
                zeichenflaeche.zeichne(moeblierung);
            }
        });
        // Ende Ereignisprozeduren
    }


    /**
     * Definition der Menleiste
     */
    private JMenuBar machMenueLeiste() {
        // enthaltene Objekte definieren
        JMenuBar menueLeiste = new JMenuBar();

        JMenu menueDatei = new JMenu("Datei");
        JMenuItem menueEintragOeffnen = new JMenuItem("ffnen");
        JMenuItem menueEintragSpeichern = new JMenuItem("Speichern");
        JMenuItem menueEintragEnde = new JMenuItem("Ende");

        JMenu menueBearbeiten = new JMenu("Bearbeiten");
        JMenuItem menueEintragMoebelHinzufuegen = new JMenuItem("Moebel hinzufgen");
        JMenuItem menueEintragMoebelEntfernen = new JMenuItem("Moebel entfernen");

        JMenu menueEigenschaften = new JMenu("Eigenschaften");
        JMenuItem menueEintragMoebelAuswaehlen = new JMenuItem("Moebel auswhlen");
        JMenuItem menueEintragMoebelVerschieben = new JMenuItem("Moebel verschieben");
        JMenuItem menueEintragMoebelUmfaerben = new JMenuItem("Moebelfarbe ndern");
        JMenuItem menueEintragMoebelMasse = new JMenuItem("Moebelmae ndern");

        // Listener definieren
        menueEintragOeffnen.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("ffnen - nicht implementiert");
           }
        });

        menueEintragSpeichern.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("Speichern - nicht implementiert");
            }
        });

        menueEintragEnde.addActionListener(new AbstractAction("Ende") {
            public void actionPerformed(ActionEvent e) {
                System.exit(0);
            }
        });

        menueEintragMoebelHinzufuegen.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                uebernehmenAktion();
            }
        });

        menueEintragMoebelEntfernen.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("Mbel entfernen - nicht implementiert");
            }
        });

        menueEintragMoebelAuswaehlen.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                // System.out.println("Mbel auswhlen - nicht implementiert");
                // Test:
                moeblierung.start();
                moeblierung.weiter();
                moeblierung.weiter();
                moeblierung.waehleAus();
                zeichenflaeche.zeichne(moeblierung);
            }
        });

        menueEintragMoebelVerschieben.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("Mbel verschieben - nicht implementiert");
            }
        });

        menueEintragMoebelUmfaerben.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("Moebelfarbe ndern - nicht implementiert");
            }
        });

        menueEintragMoebelMasse.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("Moebelmae ndern - nicht implementiert");
            }
        });


        // hinzufgen
        menueDatei.add(menueEintragOeffnen);
        menueDatei.add(menueEintragSpeichern);
        menueDatei.add(menueEintragEnde);

        menueBearbeiten.add(menueEintragMoebelHinzufuegen);
        menueBearbeiten.add(menueEintragMoebelEntfernen);

        menueEigenschaften.add(menueEintragMoebelAuswaehlen);
        menueEigenschaften.add(menueEintragMoebelVerschieben);
        menueEigenschaften.add(menueEintragMoebelUmfaerben);
        menueEigenschaften.add(menueEintragMoebelMasse);

        menueLeiste.add(menueDatei);
        menueLeiste.add(menueBearbeiten);
        menueLeiste.add(menueEigenschaften);

        return menueLeiste;
    }
    // Ende der Definitionsmethode fr die Menleiste
    
    // Commands
    private void uebernehmenAktion(){
        if (!moeblierung.neuesMoebel(
                jButtonGroup1.getSelection().getActionCommand(),
                editXPosition.getText(),
                editYPosition.getText(),
                editFarbe.getText(),
                editRichtung.getText(),
                editBreite.getText(),
                editTiefe.getText()))
        JOptionPane.showMessageDialog(this, "Fehler bei den Daten");
        else zeichenflaeche.zeichne(moeblierung);
    }    

// // ScrollPane mit JList zur Moebelauswahl
// private class MoebelAuswahlScrollPane extends JScrollPane{
//     private JList jList1Daten;
//     public MoebelAuswahlScrollPane()
//     for (int i=0;i<10; i++) {
//        jList1Daten[9-i] = ""+i;
//     }
//     jList1 = new JList(jList1Daten);
//     jList1.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
//     jList1.setSelectedIndex(0);
//     scrollPane = new JScrollPane(jList1);
//     scrollPane.setBounds(120, 16, 30, 20);
//     cp.add(scrollPane);
//     scrollBar = scrollPane.getVerticalScrollBar();
//     scrollBar.addAdjustmentListener(new AdjustmentListener() {
//         public void adjustmentValueChanged(AdjustmentEvent e){
//             jList1.setSelectedIndex(scrollBar.getValue()/18);
//             // warum das hier 18 sind, ist unklar. Schrifthoehe?
//         }
//     });    
// }    
    
    
        
    public static void main(String[] args) {
        moeblierung = new Moeblierung();
        gui = new Gui("Gui", 600, 600);
    }
}

